# Class IdentityHashMap<K,V>

java.lang.Object
java.util.AbstractMap<K,V>
java.util.IdentityHashMap<K,V>

All Implemented Interfaces:
  `Map<K,V>`

public class IdentityHashMap<K,V> extends AbstractMap<K,V> implements Map<K,V>

IdentityHashMap is a variant on HashMap which tests equality by reference instead of equality by value. Basically, keys and values are compared for equality by checking if their references are equal rather than by calling the "equals" function.

Note: This class intentionally violates the general contract of `Map`'s on comparing objects by their `equals` method.

IdentityHashMap uses open addressing (linear probing in particular) for collision resolution. This is different from HashMap which uses Chaining.

Like HashMap, IdentityHashMap is not thread safe, so access by multiple threads must be synchronized by an external mechanism such as Collections.synchronizedMap.

##### Since

1.4

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class AbstractMap

  `AbstractMap.SimpleEntry<K,V>, AbstractMap.SimpleImmutableEntry<K,V>`

  ### Nested classes/interfaces inherited from interface Map

  `Map.Entry<K,V>`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `IdentityHashMap()`
  Creates an IdentityHashMap with default expected maximum size.
  `IdentityHashMap(int maxSize)`
  Creates an IdentityHashMap with the specified maximum size parameter.
  `IdentityHashMap(Map<? extends K, ? extends V> map)`
  Creates an IdentityHashMap using the given map as initial values.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `clear()`
  Removes all elements from this map, leaving it empty.
  `boolean`
  `containsKey(java.lang.Object key)`
  Returns whether this map contains the specified key.
  `boolean`
  `containsValue(java.lang.Object value)`
  Returns whether this map contains the specified value.
  `Set<Map.Entry<K,V>>`
  `entrySet()`
  Returns a set containing all of the mappings in this map.
  `boolean`
  `equals(java.lang.Object object)`
  Compares this map with other objects.
  `V`
  `get(java.lang.Object key)`
  Returns the value of the mapping with the specified key.
  `boolean`
  `isEmpty()`
  Returns whether this IdentityHashMap has no elements.
  `Set<K>`
  `keySet()`
  Returns a set of the keys contained in this map.
  `V`
  `put(K key, V value)`
  Maps the specified key to the specified value.
  `void`
  `putAll(Map<? extends K, ? extends V> map)`
  Copies all the mappings in the specified map to this map.
  `V`
  `remove(java.lang.Object key)`
  Removes the mapping with the specified key from this map.
  `int`
  `size()`
  Returns the number of mappings in this IdentityHashMap.
  `Collection<V>`
  `values()`
  Returns a collection of the values contained in this map.

  ### Methods inherited from class AbstractMap

  `hashCode, toString`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface Map

  `compute, computeIfAbsent, computeIfPresent, forEach, getOrDefault, hashCode, merge, putIfAbsent, remove, replace, replace, replaceAll`

- ## Constructor Details

  - ### IdentityHashMap

    public IdentityHashMap()
    Creates an IdentityHashMap with default expected maximum size.

  - ### IdentityHashMap

    public IdentityHashMap(int maxSize)

    Creates an IdentityHashMap with the specified maximum size parameter.

    ###### Parameters

    - `maxSize`: @param maxSize The estimated maximum number of entries that will be put in this map.

  - ### IdentityHashMap

    public IdentityHashMap(Map<? extends K, ? extends V> map)

    Creates an IdentityHashMap using the given map as initial values.

    ###### Parameters

    - `map`: A map of (key,value) pairs to copy into the IdentityHashMap.

- ## Method Details

  - ### clear

    public void clear()

    Removes all elements from this map, leaving it empty.

    ###### See also

    - #isEmpty()

    - #size()

    Specified by:
      `clear` in interface `Map<K,V>`
    Overrides:
      `clear` in class `AbstractMap<K,V>`

  - ### containsKey

    public boolean containsKey(java.lang.Object key)

    Returns whether this map contains the specified key.

    ###### Parameters

    - `key`: the key to search for.

    ###### Returns

    Specified by:
      `containsKey` in interface `Map<K,V>`
    Overrides:
      `containsKey` in class `AbstractMap<K,V>`
    Returns:
      `true` if this map contains the specified key, `false` otherwise.

  - ### containsValue

    public boolean containsValue(java.lang.Object value)

    Returns whether this map contains the specified value.

    ###### Parameters

    - `value`: the value to search for.

    ###### Returns

    Specified by:
      `containsValue` in interface `Map<K,V>`
    Overrides:
      `containsValue` in class `AbstractMap<K,V>`
    Returns:
      `true` if this map contains the specified value, `false` otherwise.

  - ### get

    public V get(java.lang.Object key)

    Returns the value of the mapping with the specified key.

    ###### Parameters

    - `key`: the key.

    ###### Returns

    the value of the mapping with the specified key.

    Specified by:
      `get` in interface `Map<K,V>`
    Overrides:
      `get` in class `AbstractMap<K,V>`
    Returns:
      the value of the mapping with the specified key, or `null` if no mapping for the specified key is found.

  - ### put

    public V put(K key, V value)

    Maps the specified key to the specified value.

    ###### Parameters

    - `key`: the key.

    - `value`: the value.

    ###### Returns

    Specified by:
      `put` in interface `Map<K,V>`
    Overrides:
      `put` in class `AbstractMap<K,V>`
    Returns:
      the value of any previous mapping with the specified key or `null` if there was no such mapping.

  - ### putAll

    public void putAll(Map<? extends K, ? extends V> map)

    Copies all the mappings in the specified map to this map. These mappings will replace all mappings that this map had for any of the keys currently in the given map.

    ###### Parameters

    - `map`: the map to copy mappings from.

    ###### Throws

    - `NullPointerException`: if `map` is `null`.
    Specified by:
      `putAll` in interface `Map<K,V>`
    Overrides:
      `putAll` in class `AbstractMap<K,V>`

  - ### remove

    public V remove(java.lang.Object key)

    Removes the mapping with the specified key from this map.

    ###### Parameters

    - `key`: the key of the mapping to remove.

    ###### Returns

    Specified by:
      `remove` in interface `Map<K,V>`
    Overrides:
      `remove` in class `AbstractMap<K,V>`
    Returns:
      the value of the removed mapping, or `null` if no mapping for the specified key was found.

  - ### entrySet

    public Set<Map.Entry<K,V>> entrySet()

    Returns a set containing all of the mappings in this map. Each mapping is an instance of `Map.Entry`. As the set is backed by this map, changes in one will be reflected in the other.

    ###### Returns

    a set of the mappings.

    Specified by:
      `entrySet` in interface `Map<K,V>`
    Specified by:
      `entrySet` in class `AbstractMap<K,V>`

  - ### keySet

    public Set<K> keySet()

    Returns a set of the keys contained in this map. The set is backed by this map so changes to one are reflected by the other. The set does not support adding.

    ###### Returns

    a set of the keys.

    Specified by:
      `keySet` in interface `Map<K,V>`
    Overrides:
      `keySet` in class `AbstractMap<K,V>`

  - ### values

    public Collection<V> values()

    Returns a collection of the values contained in this map. The collection is backed by this map so changes to one are reflected by the other. The collection supports remove, removeAll, retainAll and clear operations, and it does not support add or addAll operations.

    This method returns a collection which is the subclass of AbstractCollection. The iterator method of this subclass returns a "wrapper object" over the iterator of map's entrySet(). The `size` method wraps the map's size method and the `contains` method wraps the map's containsValue method.

    The collection is created when this method is called for the first time and returned in response to all subsequent calls. This method may return different collections when multiple concurrent calls occur, since no synchronization is performed.

    ###### Returns

    a collection of the values contained in this map.

    Specified by:
      `values` in interface `Map<K,V>`
    Overrides:
      `values` in class `AbstractMap<K,V>`

  - ### equals

    public boolean equals(java.lang.Object object)

    Compares this map with other objects. This map is equal to another map is it represents the same set of mappings. With this map, two mappings are the same if both the key and the value are equal by reference. When compared with a map that is not an IdentityHashMap, the equals method is neither necessarily symmetric (a.equals(b) implies b.equals(a)) nor transitive (a.equals(b) and b.equals(c) implies a.equals(c)).

    ###### Parameters

    - `object`: the object to compare to.

    ###### Returns

    whether the argument object is equal to this object.

    Specified by:
      `equals` in interface `Map<K,V>`
    Overrides:
      `equals` in class `AbstractMap<K,V>`
    Returns:

      boolean `true` if the object is the same as this object, and `false` if it is different from this object.

      ###### See also

      - #hashCode()

      - #entrySet()

  - ### isEmpty

    public boolean isEmpty()

    Returns whether this IdentityHashMap has no elements.

    ###### Returns

    Specified by:
      `isEmpty` in interface `Map<K,V>`
    Overrides:
      `isEmpty` in class `AbstractMap<K,V>`
    Returns:

      `true` if this IdentityHashMap has no elements, `false` otherwise.

      ###### See also

      - #size()

  - ### size

    public int size()

    Returns the number of mappings in this IdentityHashMap.

    ###### Returns

    the number of mappings in this IdentityHashMap.

    Specified by:
      `size` in interface `Map<K,V>`
    Overrides:
      `size` in class `AbstractMap<K,V>`